/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

#if !defined(lint) && defined(SCCSIDS)
static char sccsid[] = "@(#)server_tli.c  1.3  92/06/22  Copyr 1988 Sun Micro";
#endif

#include <stdio.h>
#include <rpc/rpc.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netconfig.h>
#include <rpc/nettype.h>
#include <errno.h>
#include "test.h"
#include <poll.h>

#define	RPC_RQST_SZ 28		/* size of an RPC header with AUTH_NULL */
#define	RPC_REPLY_SZ 16
#define	RPC_MAX_SZ 33000
#define	MAX_OPT_WORDS	32



struct list {
	SVCXPRT *server;
	int type;
};

struct svc {
	struct list l[10];
} svc;

char ansbuf[RPC_REPLY_SZ];
char buf[RPC_MAX_SZ];



extern int t_errno;
main()
{
  int tcpsock, udpsock, msgsock;
  struct sockaddr_in sin;
  int ln;
  int rval;
  struct pollfd pollfds[3];
  int i, len;
  int tlen, value;
  struct netconfig *nconf;
  void *net;
  int svctot = 0;

  if ((net = __rpc_setconf("NETPATH")) == 0) {
    (void) fprintf(stderr, "svc_create: unknown protocol\n");
    exit(1);
  }

  while (nconf = __rpc_getconf(net)) {
    svc.l[svctot].server = svc_tp_create(NULL, PERF_TLI,
					 VERS_ONE, nconf);
    if (svc.l[svctot].server == NULL) {
      fprintf(stderr, "Could not create handle for %s\n",
	      nconf->nc_netid);
    } else {
      pollfds[svctot].fd=svc.l[svctot].server->xp_fd;
      pollfds[svctot].events=POLLIN;
      svc.l[svctot].type = nconf->nc_semantics;
      svctot++;
    }
  }
  __rpc_endconf(net);
  if (svctot == 0) {
    fprintf(stderr, "No services registered\n");
    exit(1);
  }
#ifdef DEBUG
  fprintf(stderr, "no of transports %d\n", svctot);
#endif
  for (i = 0; i < RPC_REPLY_SZ - 1; i++)
    ansbuf[i] = 'a';
  ansbuf[RPC_REPLY_SZ - 1] = NULL;

  while (TRUE) {
    if (poll(pollfds,3,-1) < 0) {
      perror("select");
      exit(1);
    }
    for (i = 0; i < svctot; i++) 
      if (pollfds[i].revents == POLLIN) {
	if (svc.l[i].type == NC_TPI_CLTS) {
	  do_dg(svc.l[i].server);
	} else {
	  do_vc(svc.l[i].server);
	} ;
      };
  };
}


struct svc_dg_data {
	struct	netbuf optbuf;
	long	opts[MAX_OPT_WORDS];		/* options */
	u_int   su_iosz;			/* size of send.recv buffer */
	u_long	su_xid;				/* transaction id */
	XDR	su_xdrs;			/* XDR handle */
	char	su_verfbody[MAX_AUTH_BYTES];	/* verifier body */
	char 	*su_cache;			/* cached data, NULL if none */
};
#define	su_data(xprt)	((struct svc_dg_data *)(xprt->xp_p2))
#define	rpc_buffer(xprt) ((xprt)->xp_p1)

do_dg(xprt)
	SVCXPRT *xprt;
{
	register struct svc_dg_data *su = su_data(xprt);
	struct t_unitdata tu_data;
	int moreflag;		/* Flag indicating more data */
	int res;

	tu_data.addr = xprt->xp_rtaddr;
	tu_data.udata.buf = (char *)rpc_buffer(xprt);
	tu_data.opt.buf= (char *) su->opts;
	/*
	 * If moreflag is set, drop that data packet. Something wrong
	 */
again:
	tu_data.addr.len = 0;
	tu_data.opt.len  = 0;
	tu_data.udata.len  = 0;

	tu_data.udata.maxlen = su->su_iosz;
	tu_data.opt.maxlen = MAX_OPT_WORDS <<2;

	moreflag = 0;

	if (t_rcvudata(xprt->xp_fd, &tu_data, &moreflag) == -1) {
		t_error("could not read datagram");
		return (FALSE);
	}

	if ((moreflag) || (tu_data.udata.len < 4 * sizeof (u_long)))
		return (FALSE);

	res = *(int *)tu_data.udata.buf;
#ifdef PDEBUG
	tu_data.udata.buf[tu_data.udata.len] = NULL;
	printf("--> %s\n", tu_data.udata.buf);
#endif
	tu_data.udata.buf = ansbuf;
	tu_data.udata.len = (u_int)sizeof (ansbuf);
	*(int *)tu_data.udata.buf = res;

	tu_data.opt.len = 0;
	(void) t_sndudata(xprt->xp_fd, &tu_data);
	return (TRUE);
}

do_vc(xprt)
	SVCXPRT *xprt;
{
	struct t_call *t_call, t_call2;
	struct t_bind *res = NULL;
	int fd, tlen, rval, len, value,flags;
	int result;

	t_call = (struct t_call *) t_alloc(xprt->xp_fd,
				T_CALL, T_ADDR | T_OPT);
	if (t_call == NULL) {
		(void) t_error("rendezvous_request: no memory");
		exit(1);
	}
	if (t_listen(xprt->xp_fd, t_call) == -1) {
		t_error("could not accept");
		exit(1);
	}

	fd = t_open(xprt->xp_tp, O_RDWR, NULL);
	if (fd == -1) {
		t_error("cannot open file descriptor");
		exit(1);
	}
	if (t_bind(fd, (struct t_bind *)NULL, NULL) == -1) {
		t_error("cannot bind svc connection");
		exit(1);
	}
/*
	t_call2=*t_call;
	t_call2.opt.len = 0;
	t_call2.opt.maxlen = 0;
	t_call2.opt.buf = NULL;

	fd=xprt->xp_fd;
*/
	if (t_accept(xprt->xp_fd, fd,  t_call) == -1) {
		if (t_errno == TLOOK)
			(void) t_rcvdis(xprt->xp_fd, NULL);
		t_error("cannot accept connection");
		exit(1);
	}
	result = -1;
	do {
		if ((len = t_rcv(fd, (char *)&value, sizeof (int),
			(int *)&flags) <= 0)) {
#ifdef DEBUG
			perror("ending connections");
#endif
			break;
		}
		tlen = ntohl(value);
#ifdef DEBUG
		printf("len = %d\n", tlen);
#endif
		do {
			if ((rval = t_rcv(fd, buf, tlen,
				(int *) &flags)) < 0) {
#ifdef DEBUG
				perror("could not read messages");

#endif
				rval = 0;
				break;
			}
			if (rval == 0) {
#ifdef DEBUG
				printf("Ending connections\n");
#endif
				break;
			}
			if (result == -1) {
				result = *(int *)buf/*[RPC_RQST_SZ]*/;
			}
#ifdef PDEBUG
			buf[rval] = NULL;
			printf("--> %s\n", buf);
#endif
			tlen -= rval;
			if (tlen == 0) {
				/* Reply this message, No more data */
				if (result != -1) {
					*(int *)ansbuf = result;
					result = -1;
				}
				if ((len = t_snd(fd, ansbuf, sizeof (ansbuf),
					(int)0)) == -1) {
					perror("error in sending COTS data");
					exit(1);
				}
				break;
			};
		} while (tlen != 0);
	} while (rval != 0);
	t_close(fd);
	t_free(t_call, T_CALL);
	return (TRUE);
}

t_error(s)
	char *s;
{
	perror(s);
}
